/* C code produced by gperf version 3.0.4 */
/* Command-line: gperf -tCcTnD -K id frametab.gperf  */
/* Computed positions: -k'1-4' */

#if !((' ' == 32) && ('!' == 33) && ('"' == 34) && ('#' == 35) \
      && ('%' == 37) && ('&' == 38) && ('\'' == 39) && ('(' == 40) \
      && (')' == 41) && ('*' == 42) && ('+' == 43) && (',' == 44) \
      && ('-' == 45) && ('.' == 46) && ('/' == 47) && ('0' == 48) \
      && ('1' == 49) && ('2' == 50) && ('3' == 51) && ('4' == 52) \
      && ('5' == 53) && ('6' == 54) && ('7' == 55) && ('8' == 56) \
      && ('9' == 57) && (':' == 58) && (';' == 59) && ('<' == 60) \
      && ('=' == 61) && ('>' == 62) && ('?' == 63) && ('A' == 65) \
      && ('B' == 66) && ('C' == 67) && ('D' == 68) && ('E' == 69) \
      && ('F' == 70) && ('G' == 71) && ('H' == 72) && ('I' == 73) \
      && ('J' == 74) && ('K' == 75) && ('L' == 76) && ('M' == 77) \
      && ('N' == 78) && ('O' == 79) && ('P' == 80) && ('Q' == 81) \
      && ('R' == 82) && ('S' == 83) && ('T' == 84) && ('U' == 85) \
      && ('V' == 86) && ('W' == 87) && ('X' == 88) && ('Y' == 89) \
      && ('Z' == 90) && ('[' == 91) && ('\\' == 92) && (']' == 93) \
      && ('^' == 94) && ('_' == 95) && ('a' == 97) && ('b' == 98) \
      && ('c' == 99) && ('d' == 100) && ('e' == 101) && ('f' == 102) \
      && ('g' == 103) && ('h' == 104) && ('i' == 105) && ('j' == 106) \
      && ('k' == 107) && ('l' == 108) && ('m' == 109) && ('n' == 110) \
      && ('o' == 111) && ('p' == 112) && ('q' == 113) && ('r' == 114) \
      && ('s' == 115) && ('t' == 116) && ('u' == 117) && ('v' == 118) \
      && ('w' == 119) && ('x' == 120) && ('y' == 121) && ('z' == 122) \
      && ('{' == 123) && ('|' == 124) && ('}' == 125) && ('~' == 126))
/* The character set is not based on ISO-646.  */
error "gperf generated tables don't work with this execution character set. Please report a bug to <bug-gnu-gperf@gnu.org>."
#endif

#line 1 "frametab.gperf"
 
/* This file is part of Idest. 
   Copyright (C) 2009-2011, 2015-2017 Sergey Poznyakoff
 
   Idest is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.
 
   Idest is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with Idest.  If not, see <http://www.gnu.org/licenses/>. */

#include "idest.h"
#include "field.h"

#define QID(name) _qual_##name
#define DQ(name) static char *QID(name)[]

DQ(COMM) = { "lang", "condesc" };
DQ(TXXX) = { "condesc" };
DQ(WXXX) = { "condesc" };
DQ(APIC) = { "mime-type", "pic-type", "condesc" };

#define QUAL(name) sizeof(QID(name))/sizeof(QID(name)[0]), QID(name)
#define QUALTEXT 0, NULL

static int
decode_qv(struct ed_item *item, struct id3_frame const *frame,
	  int n, int count)
{
	union id3_field *field;
	int i;

	item->qc = count;
	item->qv = xcalloc(item->qc, sizeof(item->qv[0]));
	for (i = 0; i < count; i++) {
		field = id3_frame_field(frame, n + i);
		if (!field)
			break;
		item->qv[i] = field_to_string(field, frame);
	}
	return 0;
}

char *_idest_errstr[] = {
	"no error",
	"no such field",
	"bad conversion",
	"set error",
	"operation not supported",
	"unknown type",
	"field number out of range"
};
int _idest_nerrs = sizeof(_idest_errstr)/sizeof(_idest_errstr[0]);

const char *
idest_strerror(int code)
{
	if (code < 0 || code > _idest_nerrs)
		return "unknown error";
	return _idest_errstr[code];
}

int
frame_field_from_string(struct id3_frame *frame, int n, const char *value)
{
	int rc = 0, res = 0;
	enum id3_field_type type;
	union id3_field *field;
	id3_ucs4_t *ucs4;
	struct id3_frametype const *frametype =
		id3_frametype_lookup(frame->id, 4);

	if (!frametype)
		return IDEST_ERR_BADTYPE;
	if (n > frametype->nfields - 1)
                 /* last field is supposed to be a value */
		return IDEST_ERR_BADFIELD;
	type = frametype->fields[n];
	
	field = id3_frame_field(frame, n);
	if (!field)
		return IDEST_ERR_NOFIELD;
	if (type == ID3_FIELD_TYPE_TEXTENCODING) {
		/* Special case */
		if (id3_field_settextencoding(field, textual_frame_encoding))
			rc = IDEST_ERR_SET;
		return rc;
	}

	if (!value) {
		id3_field_init(field, type);
		return 0;
	}

	switch (type) {
	case ID3_FIELD_TYPE_INT8:
	case ID3_FIELD_TYPE_INT16:
	case ID3_FIELD_TYPE_INT24:
	case ID3_FIELD_TYPE_INT32: {
		char *p;
		signed long number = strtoul(value, &p, 10);
		if (*p)
			rc = IDEST_ERR_BADCONV;
		else
			res = id3_field_setint(field, number);
		break;
	}

	case ID3_FIELD_TYPE_LATIN1:
	case ID3_FIELD_TYPE_LATIN1FULL:
		res = id3_field_setlatin1(field, (id3_latin1_t const *)value);
		break;

	case ID3_FIELD_TYPE_LATIN1LIST:
		/* FIXME */
		rc = IDEST_ERR_NOTSUPP;
		break;

	case ID3_FIELD_TYPE_STRING:
		ucs4 = id3_utf8_ucs4duplicate((const id3_utf8_t *)value);
		res = id3_field_setstring(field, ucs4);
		free(ucs4);
		break;

	case ID3_FIELD_TYPE_STRINGFULL:
		ucs4 = id3_utf8_ucs4duplicate((const id3_utf8_t *)value);
		res = id3_field_setfullstring(field, ucs4);
		free(ucs4);
		break;

	case ID3_FIELD_TYPE_STRINGLIST:
		ucs4 = id3_utf8_ucs4duplicate((const id3_utf8_t *)value);
		res = id3_field_setstrings(field, 1, &ucs4);
		free(ucs4);
		break;

	case ID3_FIELD_TYPE_LANGUAGE:
		res = id3_field_setlanguage(field, value);
		break;
		
	case ID3_FIELD_TYPE_FRAMEID:
		res = id3_field_setframeid(field, value);
		break;
		
	case ID3_FIELD_TYPE_DATE:
		/* FIXME: Convert and copy 8 bytes into
		   field->immediate.value */
		rc = IDEST_ERR_NOTSUPP;
		break;
		
	case ID3_FIELD_TYPE_INT32PLUS:
	case ID3_FIELD_TYPE_BINARYDATA:
		rc = field_binary_from_string(field, value);
		break;

	default:
		rc = IDEST_ERR_BADTYPE;
	}
	if (rc == 0 && res)
		rc = IDEST_ERR_SET;
	return rc;
}

int
frame_field_from_rawdata(struct id3_frame *frame, int n,
			 enum id3_field_type type,
			 const char *value)
{
	int rc = 0, res = 0;
	union id3_field *field;
	id3_ucs4_t *ucs4;

	field = id3_frame_field(frame, n);
	if (!field)
		return IDEST_ERR_NOFIELD;
	if (type == ID3_FIELD_TYPE_TEXTENCODING) {
		/* Special case */
		if (id3_field_settextencoding(field, textual_frame_encoding))
			rc = IDEST_ERR_SET;
		return rc;
	}

	switch (type) {
	case ID3_FIELD_TYPE_INT8:
	case ID3_FIELD_TYPE_INT16:
	case ID3_FIELD_TYPE_INT24:
	case ID3_FIELD_TYPE_INT32: {
		char *p;
		signed long number = strtoul(value, &p, 10);
		if (*p)
			rc = IDEST_ERR_BADCONV;
		else
			res = id3_field_setint(field, number);
		break;
	}

	case ID3_FIELD_TYPE_LATIN1:
	case ID3_FIELD_TYPE_LATIN1FULL:
		res = id3_field_setlatin1(field, (id3_latin1_t const *)value);
		break;

	case ID3_FIELD_TYPE_LATIN1LIST:
		/* FIXME */
		rc = IDEST_ERR_NOTSUPP;
		break;

	case ID3_FIELD_TYPE_STRING:
		ucs4 = id3_utf8_ucs4duplicate((const id3_utf8_t *)value);
		res = id3_field_setstring(field, ucs4);
		free(ucs4);
		break;

	case ID3_FIELD_TYPE_STRINGFULL:
		ucs4 = id3_utf8_ucs4duplicate((const id3_utf8_t *)value);
		res = id3_field_setfullstring(field, ucs4);
		free(ucs4);
		break;

	case ID3_FIELD_TYPE_STRINGLIST:
		ucs4 = id3_utf8_ucs4duplicate((const id3_utf8_t *)value);
		res = id3_field_setstrings(field, 1, &ucs4);
		free(ucs4);
		break;

	case ID3_FIELD_TYPE_LANGUAGE:
		res = id3_field_setlanguage(field, value);
		break;
		
	case ID3_FIELD_TYPE_FRAMEID:
		res = id3_field_setframeid(field, value);
		break;
		
	case ID3_FIELD_TYPE_DATE:
		/* FIXME: Convert and copy 8 bytes into
		   field->immediate.value */
		rc = IDEST_ERR_NOTSUPP;
		break;
		
	case ID3_FIELD_TYPE_INT32PLUS:
	case ID3_FIELD_TYPE_BINARYDATA:
		rc = field_binary_from_string(field, value);
		break;

	default:
		rc = IDEST_ERR_BADTYPE;
	}
	if (rc == 0 && res)
		rc = IDEST_ERR_SET;
	return rc;
}

static int
encode_qv(struct id3_frame *frame, int frameoff, const struct ed_item *item)	
{
	int i;
	
	for (i = 0; i < item->qc; i++) {
		int rc = frame_field_from_string(frame, i + frameoff,
						 item->qv[i]);
		if (rc)
			return rc;
	}
	return 0;
}


static int
comm_cmp(struct id3_frame const *frame, const struct ed_item const *item)
{
	int rc;
	struct ed_item itm;
	
	memset(&itm, 0, sizeof(itm));
	if (decode_qv(&itm, frame, 1, 2))
		return 1;
	
	rc = ed_item_qv_cmp(&itm, item);
	ed_item_free_content(&itm);
	return rc;
}

static int
comm_encode(struct id3_frame *frame, const struct ed_item *item)
{
	int rc;
	union id3_field *field;
	id3_ucs4_t *ucs4;

        /* Set encoding */
	rc = frame_field_from_string(frame, 0, NULL);
	if (rc)
		return rc;
	/* Set rest of subfields */
	rc = encode_qv(frame, 1, item);
	if (rc)
		return rc;
	
	field = id3_frame_field(frame, 3);
	ucs4 = id3_utf8_ucs4duplicate((const id3_utf8_t *) item->value);
	if (id3_field_setfullstring(field, ucs4))
		rc = IDEST_ERR_SET;
	free(ucs4);
	return rc;
}

static int
comm_decode(struct ed_item *item, struct id3_frame const *frame)
{
	int rc;
	union id3_field *field;
	
	if ((rc = decode_qv(item, frame, 1, 2)))
		return rc;
	field = id3_frame_field(frame, 3);
	if (!field)
		return IDEST_ERR_NOFIELD;
	item->value = field_to_string(field, 0);
	
	return 0;
}

static int
text_encode(struct id3_frame *frame, struct ed_item const *item)
{
	const char *value = item->value;
	union id3_field *field;
	id3_ucs4_t *ucs4;

	field = id3_frame_field(frame, 0);
	id3_field_settextencoding(field, textual_frame_encoding);

	ucs4 = id3_utf8_ucs4duplicate((const id3_utf8_t *)value);
	
	field = id3_frame_field(frame, 1);
	id3_field_setstrings(field, 1, &ucs4);
	free(ucs4);
	return 0;
}

static int
text_decode(struct ed_item *item, struct id3_frame const *frame)
{
	union id3_field *field;
	char *str;
	int rc;

	field = id3_frame_field(frame, 1);
	if (!field)
		return IDEST_ERR_NOFIELD;
	str = field_to_string(field, frame);
	rc = utf8_convert(idest_conv_decode, str, &item->value);
	free(str);
	if (rc)
		return IDEST_ERR_BADCONV;
	return 0;
}

static int
txxx_cmp(struct id3_frame const *frame, const struct ed_item const *item)
{
	int rc;
	struct ed_item itm;
	
	memset(&itm, 0, sizeof(itm));
	if (decode_qv(&itm, frame, 1, 1))
		return 1;
	
	rc = ed_item_qv_cmp(&itm, item);
	ed_item_free_content(&itm);
	return rc;
}

static int
txxx_encode(struct id3_frame *frame, const struct ed_item *item)
{
	int rc;
	union id3_field *field;
	id3_ucs4_t *ucs4;

        /* Set encoding */
	rc = frame_field_from_string(frame, 0, NULL);
	if (rc)
		return rc;
	/* Set rest of subfields */
	rc = encode_qv(frame, 1, item);
	if (rc)
		return rc;
	
	field = id3_frame_field(frame, 2);
	ucs4 = id3_utf8_ucs4duplicate((const id3_utf8_t *) item->value);
	if (id3_field_setstring(field, ucs4))
		rc = IDEST_ERR_SET;
	free(ucs4);
	return rc;
}

static int
txxx_decode(struct ed_item *item, struct id3_frame const *frame)
{
	int rc;
	union id3_field *field;
	
	if ((rc = decode_qv(item, frame, 1, 1)))
		return rc;
	field = id3_frame_field(frame, 2);
	if (!field)
		return IDEST_ERR_NOFIELD;
	item->value = field_to_string(field, 0);
	
	return 0;
}

/* FIXME: Comparator is defined, but there is still no way to
   address multiple URL frames in the tag, as they lack qualifiers.
*/
static int
url_cmp(struct id3_frame const *frame, const struct ed_item const *item)
{
	int rc;
	union id3_field *field;
	char *value;

	field = id3_frame_field(frame, 0);
	if (!field)
		return 1;
	value = field_to_string(field, 0);
	rc = strcmp(value, item->value);
	free(value);
	return rc;
}

static int
url_encode(struct id3_frame *frame, const struct ed_item *item)
{
	return frame_field_from_string(frame, 0, item->value);
}

static int
url_decode(struct ed_item *item, struct id3_frame const *frame)
{
	union id3_field *field;

	field = id3_frame_field(frame, 0);
	if (!field)
		return IDEST_ERR_NOFIELD;
	item->value = field_to_string(field, 0);
	
	return 0;
}

static int
wxxx_cmp(struct id3_frame const *frame, const struct ed_item const *item)
{
	int rc;
	struct ed_item itm;
	
	memset(&itm, 0, sizeof(itm));
	if (decode_qv(&itm, frame, 1, 1))
		return 1;
	
	rc = ed_item_qv_cmp(&itm, item);
	ed_item_free_content(&itm);
	return rc;
}

static int
wxxx_encode(struct id3_frame *frame, const struct ed_item *item)
{
	int rc;

	/* Set encoding */
	rc = frame_field_from_string(frame, 0, NULL);
	if (rc)
		return rc;

	/* Set subfields */
	rc = encode_qv(frame, 1, item);
	if (rc)
		return rc;
	return frame_field_from_string(frame, 2, item->value);
}

static int
wxxx_decode(struct ed_item *item, struct id3_frame const *frame)
{
	int rc;
	union id3_field *field;
	
	if ((rc = decode_qv(item, frame, 1, 1)))
		return rc;
	
	field = id3_frame_field(frame, 2);
	if (!field)
		return IDEST_ERR_NOFIELD;
	item->value = field_to_string(field, 0);
	
	return 0;
}

static int
apic_cmp(struct id3_frame const *frame, const struct ed_item const *item)
{
	int rc;
	struct ed_item itm;
	
	memset(&itm, 0, sizeof(itm));
	if (decode_qv(&itm, frame, 1, 3))
		return 1;
	
	rc = ed_item_qv_cmp(&itm, item);
	ed_item_free_content(&itm);
	return rc;
}

static int
apic_encode(struct id3_frame *frame, const struct ed_item *item)
{
	int rc;

	/* Set encoding */
	rc = frame_field_from_string(frame, 0, NULL);
	if (rc)
		return rc;

	/* Set subfields */
	rc = encode_qv(frame, 1, item);
	if (rc)
		return rc;
	return frame_field_from_string(frame, 4, item->value);
}

static int
apic_decode(struct ed_item *item, struct id3_frame const *frame)
{
	int rc;
	union id3_field *field;
	
	if ((rc = decode_qv(item, frame, 1, 3)))
		return rc;
	
	field = id3_frame_field(frame, 4);
	if (!field)
		return IDEST_ERR_NOFIELD;
	item->value = field_to_string(field, 0);
	
	return 0;
}


#define TOTAL_KEYWORDS 58
#define MIN_WORD_LENGTH 4
#define MAX_WORD_LENGTH 4
#define MIN_HASH_VALUE 1
#define MAX_HASH_VALUE 156
/* maximum key range = 156, duplicates = 0 */

#ifdef __GNUC__
__inline
#else
#ifdef __cplusplus
inline
#endif
#endif
/*ARGSUSED*/
static unsigned int
hash (str, len)
     register const char *str;
     register unsigned int len;
{
  static const unsigned char asso_values[] =
    {
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
        6,   1,  60,   0, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157,  45,   2,  45,  15,   1,
       26,   5,  30,  60, 157,   0,  25,  30,  45,   5,
       10,  46,  20,   0,   1,   5, 157,  60,   0,   0,
       36, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
      157, 157, 157, 157, 157, 157, 157
    };
  return asso_values[(unsigned char)str[3]+1] + asso_values[(unsigned char)str[2]] + asso_values[(unsigned char)str[1]] + asso_values[(unsigned char)str[0]];
}

static const struct idest_frametab wordlist[] =
  {
#line 607 "frametab.gperf"
    {"TXXX",	QUAL(TXXX),     txxx_cmp, txxx_encode, txxx_decode},
#line 606 "frametab.gperf"
    {"TSST", 	QUALTEXT,       NULL, text_encode, text_decode},
#line 574 "frametab.gperf"
    {"TEXT", 	QUALTEXT,       NULL, text_encode, text_decode  },
#line 601 "frametab.gperf"
    {"TSOA", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 603 "frametab.gperf"
    {"TSOT", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 594 "frametab.gperf"
    {"TPE4", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 592 "frametab.gperf"
    {"TPE2", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 595 "frametab.gperf"
    {"TPOS", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 591 "frametab.gperf"
    {"TPE1", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 569 "frametab.gperf"
    {"TDOR", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 567 "frametab.gperf"
    {"TDEN", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 599 "frametab.gperf"
    {"TRSN", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 605 "frametab.gperf"
    {"TSSE", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 600 "frametab.gperf"
    {"TRSO", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 582 "frametab.gperf"
    {"TLEN", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 584 "frametab.gperf"
    {"TMED", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 608 "frametab.gperf"
    {"USLT",   QUAL(COMM),     comm_cmp, comm_encode, comm_decode},
#line 604 "frametab.gperf"
    {"TSRC", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 587 "frametab.gperf"
    {"TOFN", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 580 "frametab.gperf"
    {"TKEY", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 596 "frametab.gperf"
    {"TPRO", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 589 "frametab.gperf"
    {"TOPE", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 585 "frametab.gperf"
    {"TMOO", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 572 "frametab.gperf"
    {"TDTG", 	QUALTEXT,       NULL, text_encode, text_decode  },
#line 570 "frametab.gperf"
    {"TDRC", 	QUALTEXT,       NULL, text_encode, text_decode  },
#line 602 "frametab.gperf"
    {"TSOP", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 565 "frametab.gperf"
    {"TCON", 	QUALTEXT,       NULL, text_encode, text_decode},
#line 575 "frametab.gperf"
    {"TFLT", 	QUALTEXT,       NULL, text_encode, text_decode  },
#line 563 "frametab.gperf"
    {"TBPM", 	QUALTEXT,       NULL, text_encode, text_decode},
#line 617 "frametab.gperf"
    {"WXXX",   QUAL(WXXX),     wxxx_cmp, wxxx_encode, wxxx_decode	 },
#line 597 "frametab.gperf"
    {"TPUB", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 573 "frametab.gperf"
    {"TENC", 	QUALTEXT,       NULL, text_encode, text_decode  },
#line 578 "frametab.gperf"
    {"TIT2", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 571 "frametab.gperf"
    {"TDRL", 	QUALTEXT,       NULL, text_encode, text_decode  },
#line 588 "frametab.gperf"
    {"TOLY", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 577 "frametab.gperf"
    {"TIT1", 	QUALTEXT,       NULL, text_encode, text_decode  },
#line 590 "frametab.gperf"
    {"TOWN", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 593 "frametab.gperf"
    {"TPE3", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 581 "frametab.gperf"
    {"TLAN", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 568 "frametab.gperf"
    {"TDLY", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 586 "frametab.gperf"
    {"TOAL", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 614 "frametab.gperf"
    {"WORS",   0,  NULL,       NULL, url_encode, url_decode},
#line 598 "frametab.gperf"
    {"TRCK", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 564 "frametab.gperf"
    {"TCOM", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 566 "frametab.gperf"
    {"TCOP", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 576 "frametab.gperf"
    {"TIPL", 	QUALTEXT,       NULL, text_encode, text_decode  },
#line 583 "frametab.gperf"
    {"TMCL", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 612 "frametab.gperf"
    {"WOAR",   0,  NULL,       url_cmp, url_encode, url_decode},
#line 613 "frametab.gperf"
    {"WOAS",   0,  NULL,       NULL, url_encode, url_decode},
#line 611 "frametab.gperf"
    {"WOAF",   0,  NULL,       NULL, url_encode, url_decode},
#line 562 "frametab.gperf"
    {"TALB",   QUALTEXT,       NULL, text_encode, text_decode},
#line 616 "frametab.gperf"
    {"WPUB",   0,  NULL,       NULL, url_encode, url_decode},
#line 579 "frametab.gperf"
    {"TIT3", 	QUALTEXT,       NULL, text_encode, text_decode },
#line 561 "frametab.gperf"
    {"COMM",	QUAL(COMM),	comm_cmp, comm_encode, comm_decode},
#line 560 "frametab.gperf"
    {"APIC",   QUAL(APIC),     apic_cmp, apic_encode, apic_decode},
#line 615 "frametab.gperf"
    {"WPAY",   0,  NULL,       NULL, url_encode, url_decode},
#line 609 "frametab.gperf"
    {"WCOM",   0,  NULL,       url_cmp, url_encode, url_decode},
#line 610 "frametab.gperf"
    {"WCOP",   0,  NULL,       NULL, url_encode, url_decode}
  };

static const short lookup[] =
  {
    -1,  0, -1, -1, -1, -1,  1,  2,  3, -1, -1,  4,  5,  6,
    -1, -1, -1,  7,  8, -1, -1,  9, 10, -1, -1, -1, 11, 12,
    -1, -1, -1, 13, 14, 15, -1, 16, 17, 18, 19, -1, -1, 20,
    21, -1, -1, -1, 22, 23, -1, -1, -1, 24, 25, -1, -1, -1,
    26, 27, 28, -1, 29, 30, 31, 32, -1, -1, 33, 34, 35, -1,
    -1, 36, 37, -1, -1, -1, 38, 39, -1, -1, -1, 40, -1, -1,
    -1, -1, 41, -1, -1, -1, -1, 42, -1, -1, -1, -1, 43, 44,
    -1, -1, -1, 45, -1, -1, -1, -1, 46, -1, -1, -1, 47, 48,
    -1, -1, -1, 49, 50, -1, -1, -1, 51, -1, 52, -1, -1, 53,
    -1, -1, -1, -1, 54, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 55, -1, -1,
    -1, 56, 57
  };

#ifdef __GNUC__
__inline
#if defined __GNUC_STDC_INLINE__ || defined __GNUC_GNU_INLINE__
__attribute__ ((__gnu_inline__))
#endif
#endif
const struct idest_frametab *
idest_frame_lookup_len (str, len)
     register const char *str;
     register unsigned int len;
{
  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        {
          register int index = lookup[key];

          if (index >= 0)
            {
              register const char *s = wordlist[index].id;

              if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
                return &wordlist[index];
            }
        }
    }
  return 0;
}
#line 618 "frametab.gperf"


static int wordlist_count = sizeof(wordlist)/sizeof(wordlist[0]);	 

const struct idest_frametab *
idest_frame_lookup(const char *str)
{
	return idest_frame_lookup_len(str, strlen(str));
}

static int
frametab_cmp(const void *a, const void *b)
{
	struct idest_frametab const *fta = a;
	struct idest_frametab const *ftb = b;
	return strcmp(fta->id, ftb->id);
}

int
frametab_enumerate(int (*fun)(const struct idest_frametab *, void *),
		   void *data, int sorted)
{
	struct idest_frametab const *ft;
	struct idest_frametab *ftbuf = NULL;
	int i;

	if (sorted) {
		ftbuf = xmalloc(sizeof(wordlist));
		memcpy(ftbuf, wordlist, sizeof(wordlist));
		qsort(ftbuf, wordlist_count, sizeof(ftbuf[0]), frametab_cmp);
		ft = ftbuf;
	} else
		ft = wordlist;
	for (i = 0; i < wordlist_count; i++) {
		int rc = fun(ft + i, data);
		if (rc)
			return rc;
	}
	free(ftbuf);
	return 0;
}


/*
Local variables:
mode: c
end:
*/  
